package etomo.ui.swing;

import java.awt.Color;
import java.awt.event.ActionEvent;

import etomo.BaseManager;
import etomo.type.AxisID;

/**
* <p>Description: </p>
* 
* <p>Copyright: Copyright 2006</p>
*
* <p>Organization:
* Boulder Laboratory for 3-Dimensional Electron Microscopy of Cells (BL3DEMC),
* University of Colorado</p>
* 
* @author $Author: sueh $
* 
* @version $Revision: a0abde197594 $
* 
* <p> $Log$
* <p> Revision 1.1  2010/11/13 16:07:35  sueh
* <p> bug# 1417 Renamed etomo.ui to etomo.ui.swing.
* <p>
* <p> Revision 1.3  2010/07/02 03:19:33  sueh
* <p> bug# 1388 Constructing super class with popupChunkWarnings equal to false.
* <p>
* <p> Revision 1.2  2007/02/19 22:14:55  sueh
* <p> bug# 964 Overriding createProcessControlPanel
* <p>
* <p> Revision 1.1  2007/02/19 22:03:37  sueh
* <p> bug# 964 Process panel for PEET interface.
* <p> </p>
*/
public class PeetProcessPanel extends AxisProcessPanel {
  public static final String rcsid = "$Id: PeetProcessPanel.java,v a0abde197594 2011/12/01 18:28:20 sueh $";

  protected void buttonKillAction(ActionEvent event) {
    manager.kill(axisID);
  }

  PeetProcessPanel(BaseManager manager) {
    super(AxisID.ONLY, manager, false);
    createProcessControlPanel();
    initializePanels();
  }

  void showBothAxis() {
  }

  private void setBackground(Color color) {
    panelRoot.setBackground(color);
    outerStatusPanel.setBackground(color);
    innerStatusPanel.setBackground(color);
    parallelStatusPanel.setBackground(color);
    panelDialog.setBackground(color);
    panelProcessSelect.setBackground(color);
    //axisButtonPanel.setBackground(color);
    progressPanel.setBackground(color);
  }

  protected void createProcessControlPanel() {
    super.createProcessControlPanel();
    showBothAxis();
  }
}
