package etomo.ui.swing;

import java.io.IOException;

import etomo.comscript.SplittiltParam;
import etomo.comscript.TiltParam;
import etomo.util.InvalidParameterException;

/**
 * <p>Description: </p>
 * 
 * <p>Copyright: Copyright 2008</p>
 *
 * <p>Organization:
 * Boulder Laboratory for 3-Dimensional Electron Microscopy of Cells (BL3DEMC),
 * University of Colorado</p>
 * 
 * @author $Author: sueh $
 * 
 * @version $Revision: 2c8860d1d527 $
 * 
 * <p> $Log$
 * <p> Revision 1.3  2011/04/04 17:36:31  sueh
 * <p> bug# 1416 Added allowTiltComSave and msgTiltComSaved.
 * <p>
 * <p> Revision 1.2  2011/02/03 06:22:16  sueh
 * <p> bug# 1422 Control of the processing method has been centralized in the
 * <p> processing method mediator class.  Implementing ProcessInterface.
 * <p> Supplying processes with the current processing method.
 * <p>
 * <p> Revision 1.1  2010/11/13 16:07:34  sueh
 * <p> bug# 1417 Renamed etomo.ui to etomo.ui.swing.
 * <p>
 * <p> Revision 3.1  2009/09/01 03:18:25  sueh
 * <p> bug# 1222
 * <p> </p>
 */
public interface TiltDisplay extends ProcessDisplay {
  public static final String rcsid = "$Id: TiltDisplay.java,v 2c8860d1d527 2011/05/03 03:45:53 sueh $";

  public boolean getParameters(TiltParam param) throws NumberFormatException,
      InvalidParameterException, IOException;

  public boolean getParameters(final SplittiltParam param);

  public boolean allowTiltComSave();
}
