c       !
c       GET_NXYZ takes a line of input and attempts to read it as 3 integers.
c       If this succeeds, the values are returned in [nxyz].  If this generates
c       an error, or the line contains letters, it then uses the line as a
c       filename and tries to open an MR file on unit [iunit].  [nxyz] is
c       then fetched from the header.
c       
c       If [pipinput] is TRUE, then the string is fetched with the given
c       [option].  Set [progname] to the name of the program if the option is
c       mandatory.  If this entry is optional, pass [progname] as a blank
c       string.
c       !
c       $Author: mast $
c       
c       $Date: 2006/08/21 16:51:07 $
c       
c       $Revision: b074ecd1489a $
c       
c       $Log$
c       Revision 3.3  2004/08/22 14:59:12  mast
c       Added line_is_filename as workaround to Windows problem
c	
c       Revision 3.2  2004/08/03 01:52:10  mast
c       Had it treat end of input same as err
c	
c       Revision 3.1  2003/12/24 18:09:38  mast
c       Converted to take PIP input
c	
c       Revision 3.1  2002/07/21 19:36:30  mast
c       Fixed treatment of / to just return and added ability for blank line
c       to do the same
c	
      subroutine get_nxyz(pipinput,option,progname,iunit,nxyz)
      implicit none
      integer*4 nxyz(3),mxyz(3),iunit,mode,i, PipGetString
      character*(*) option, progname
      character*80 line
      logical pipinput
      real*4 dmin,dmax,dmean
      logical line_is_filename
      integer*4 lnblnk

      if (.not.pipinput) then
        read(5,'(a)')line
      else
        if (PipGetString(option, line) .gt. 0) then
          if (progname .eq. ' ') return
          write(*,'(/,a,a,a,a,a)') 'ERROR: ',progname(1:lnblnk(progname)),
     &        ' - you must enter option ',option(1:lnblnk(option)),
     &        ' to specify file size or file name'
          call exit(1)
        endif
      endif
      if(line(1:1).eq.'/'.or.line.eq.' ')return
      if (line_is_filename(line)) go to 10
      read(line,*,err=10,end=10)(nxyz(i),i=1,3)
      return
10    call ialprt(.false.)
      call imopen(iunit,line,'ro')
      call irdhdr(iunit,nxyz,mxyz,mode,dmin,dmax,dmean)
      call imclose(iunit)
      call ialprt(.true.)
      return
      end


c       LINE_IS_FILENAME tests for whether a line could be a valid numeric
c       input and returns TRUE if not.  It is to replace reliance on
c       trying to read from an internal string, which fails mysteriously
c       on some Windows installations.
c       
c       String must contain spaces, tabs, period, comma, plus, minus, digits
c       
      logical function line_is_filename(line)
      implicit none
      character*(*) line
      integer*4 i, ich
      line_is_filename = .true.
      do i = 1, len(line)
        ich = ichar(line(i:i))
        if (ich .ne. 32 .and. ich .ne. 11 .and.
     &      (ich .lt. 43 .or. ich .gt. 57 .or. ich .eq. 47)) return
      enddo
      line_is_filename = .false.
      return
      end
