C       *FILTER.FOR****************************************************
C       
C       THIS SUBROUTINE DOES 2-D CONVOLUTION FILTERING IN FOURIER SPACE.
C       THE 2-D IMAGE STORED IN ARRAY IS FOURIER TRANSFORMED.
C       A RADIALLY-SYMMETRIC CONTRAST-TRANSFER FUNCTION IS APPLIED
C       IN FOURIER SPACE AND AN INVERSE TRANSFORM PERFORMED.
C       ALL OPERATIONS ARE PERFORMED IN-PLACE.
C       
C       NOTE: ARRAY MUST BE DIMENSIONED AT LEAST (NX+2,NY) TO MAKE ROOM FOR
C       FORURIER TERMS!!!!!! ALL INDEXING OF ELEMENTS IN
C       ARRAY IS CARRIED OUT EXPLICITLY = THUS ARRAY CAN BE A
C       1-D VECTOR.
C       
C       
C       CALL FILTER(ARRAY,NX,NY,CTF,DELTA)
C       
C       NX IS FAST-DIMENSION
C       DELTA IS THE RECIPROCAL-SPACE INTERVAL FOR ELEMENTS OF THE CONTRAST-
C       TRANSFER FUNCTION (CTF).  FIRST ELEMENT IS AT S=0
C       
C       VERSION 1.00            JULY 23 1981            DAA
C       
      SUBROUTINE FILTER(ARRAY,NX,NY,CTF,DELTA)
      DIMENSION ARRAY(*),CTF(*)
      COMPLEX ARRAY
C       
      CALL TODFFT(ARRAY,NX,NY,0)
C       
C       APPLY FILTER FUNCTION
C       
      call filterpart(array,array,nx,ny,ctf,delta)
C       
      CALL TODFFT(ARRAY,NX,NY,1)
C       
      RETURN
      END
