/******************************************************************************
 *
 * File:           minell.h
 *
 * Created:        24/02/2003
 *
 * Author:         Pavel Sakov
 *                 CSIRO Marine Research
 *
 * Purpose:        A header for the minimal ellipse stuff
 *
 * Revisions:      None
 *
 *****************************************************************************/
/* 
 * Incorporated into IMOD
 * $Id: minell.h,v fc47e1f966c4 2011/05/26 22:28:41 mast $ 
 */

#if !defined(_MINELL_H)
#define _MINELL_H

#if !defined(_POINT_STRUCT)
#define _POINT_STRUCT
typedef struct {
    double x;
    double y;
    double z;
} point;
#endif

#if !defined(_MINELL_STRUCT)
#define _MINELL_STRUCT
struct minell;
typedef struct minell minell;
#endif

/* Note that minell_build() shuffles the input point array */
minell* minell_build(int n, point p[]);
void minell_destroy(minell* me);
void minell_scalepoints(minell* me, int n, point p[]);
void minell_rescalepoints(minell* me, int n, point p[]);

#endif
