.TH etomo 1 2/12/2009 BL3DEMC
.na
.nh



.SH NAME
etomo - A GUI program to run IMOD and PEET batch programs



.SH SYNOPSIS
.HP
.B etomo \fR[\fIoption\fR ...] [\fIdata_file\fR ...]



.SH
DESCRIPTION
\fBEtomo\fR is an interface for running a subset of IMOD and PEET commands.  It
can be run interactively, with automation, or with a combination of
the two.  \fBEtomo\fR contain four interfaces:  one for doing tomographic
reconstructions, one for joining tomograms,  one for particle averaging, and one
for running a process using IMOD's parallel processing capabilies.
\fBEtomo\fR's standard error goes to a dated log file.  The name location of the
logs are placed in a file called \fBetomo_err.log\fR, which is placed the
current directory.  When in use, standard out is send to \fBetomo_out.log\fR.



.SH
OPTIONS

.TP
.B --axis single\fR|\fBdual
For automation.  Sets the Axis Type field in the Setup Tomogram dialog.  See
\fBUSAGE.

.TP
.B --create
For automation.  Pressed the  Create Com Scripts button in the Setup Tomogram
dialog.  See \fBUSAGE.

.TP
.B --dataset \fItilt_series_file\fR|\fIdataset_name
For automation.  Sets the Dataset Name field in the Setup Tomogram dialog.  Can
be set to a file containing a tilt series or to the dataset name.  A dataset
name is the root name of the tilt series file, excluding the extension (and the
axis extension - "a" or "b" - in the case of dual axis).  Must be in the local
directory unless the \fB--dir\fR option is used.  See \fBUSAGE.

.TP
.B --debug
Send extra information to standard error.  The \fB--debug\fR option turns on the
following options:  \fB--memory\fR and \fB--timestamp\fR.

.TP
.B --demo
Deprecated.

.TP
.B --dir \*(lq\fIdirectory_path\fB\*(rq
For automation.  The absolute or relative directory containing the file or
dataset specified with the \fB--dataset\fR option.

.TP
.B --exit
For automation.  Causes \fBetomo\fR to exit after the Setup Tomogram dialog is
completed.  See \fBUSAGE.

.TP
.B --fg
Used with automation.  Must be the first option.  Causes \fBetomo\fR to be run
in the foreground rather then in the background.  This is useful when running
\fBetomo\fR with automation from a script; a script will not wait until
\fBetomo\fR is done unless \fBetomo\fR is running in the foreground.  See
\fBUSAGE.

.TP
.B --fiducial \fIfiducial_diameter
For automation.  Sets the Fiducial Diameter field in the Setup Tomogram dialog.
\fIFiducial_diameter\fR is a double.  See \fBUSAGE.

.TP
.B --frame single\fR|\fBmontage
For automation.  Selects the Frame Type radio buttons in the Setup Tomogram
dialog.  See \fBUSAGE.

.TP
.B --headless
For testing.  No window is created.  Used for unit testing.

.TP
.B -h, --help
Send a usage message to standard out (goes to the command line not to a file)
and exit.

.TP
.B --listen
Forces all 3dmods to be run with the -L option.  This only has an effect on
Windows computers because -L is always used on Linux and Mac.  When
\fB--listen\fR is used in Windows, messages to 3dmod will be sent through stdin
rather then imodsendevent.

.TP
.B --memory \fR[\fIinterval\fR]
Log memory usage statements before and after processes are run.  The interval is
an integer which denotes the interval in minutes at which to send additional
memory usage statements.

.TP
.B --names
Used with testing.  Send the names of screen elements to standard out.  For 
writing automated regression tests.

.TP
.B --newstuff
May cause Etomo to run with unreleased functionality.

.TP
.B --scan
For automation.  Runs Scan Header in the Setup Tomogram dialog.  See \fBUSAGE.

.TP
.B --selftest
Causes \fBetomo\fR to do some internal testing.  \fBEtomo\fR may run more
slowly.

.TP
.B --test
For testing.  Test mode used for unit testing and automated regression testing.

.TP
.B --timestamp
Send timestamps to standard error before and after processes are run.



.SH USAGE


.SS Automation
Automation will be completed before handing control over to the user.
Automation parameters all affect the Reconstruction Setup dialog and should be
used without a data file.  All automation parameters are optional.  The
automation parameters will always be executed in the same order.  The order in
which they appear is ignored, except for \fB--fg\fR, which must be first.
Automation parameters are executed in the following order:  \fB--fg --dir
--dataset --axis --frame --fiducial --scan --create --exit



.SH FILES
.SS Data Files
.TP
*\fB.edf
Tomographic reconstruction data file.

.TP
*\fB.ejf
Data file for joining tomograms.

.TP
*\fB.epe
PEET data file (particle averaging).

.TP
*\fB.epp
Parallel process data file.


.SS Log Files
.TP
.B $HOME/.etomologs/etomo_err_\fItimestamp\fB.log
Contains the log. The location is configurable (see \fBman imodenv\fR).

.TP
.B etomo_err.log
Contains the location of the log.  Placed in the directory from which
\fBetomo\fR is run.

.TP
.B etomo_out.log
Contains the output of the \fB--names\fR parameter.  May also contain diagnostic
messages.  Placed in the directory from which \fBetomo\fR is run.



.SH AUTHOR
Sue Held



.SH SEE ALSO
imodenv(1), uitest(1), 3dmod(1).
