.na
.nh
.TH imodqtassist 1 3.4.16 BL3DEMC
.SH NAME
imodqtassist \- Displays pages in qch file through Qt Assistant
.SH SYNOPSIS
imodqtassist [options] path_to_help_collection_file
.SH DESCRIPTION
This program will run Qt Assistant and send it commands to display pages
in a Qt compressed help (qch) file.  The command line arguments indicate where the
help collection file is, then an individual page is displayed when its name is
entered through standard input.  
.P
The 
.B path_to_help_collection_file
is treated as a path relative to the path in the environment variable IMOD_DIR,
unless the
.B -a
option is entered to indicate that the path is absolute.
The option
.B -p
must be entered along with the name of a 
Qt help collection (qhc) file to specify that
Qt Assistant should be started with that .qhc file. 
To provide legacy
behavior, an entry of "IMOD.adp" will be accepted and translated into "IMOD.qhc".
 The help collection file
is assumed to be relative to the 
.B path_to_help_collection_file
unless it is itself an absolute file path specification.  
.P
When a line is entered through standard input, the program attempts to display
the page.  If it succeeds, it prints 
.I Page xxx displayed
to standard error and continues waiting for more input.
If it fails to find the page, there is no error message, except in Assistant itself.
If the qhc file is not found, it issues
.I WARNING: qhc file not found.
If there is actually an error starting Qt Assistant,
there will be other error messages on the first command to display a page.  In
case of these errors, the program keeps running.
.P
Enter a line with just a "q" to terminate the program and close the current 
Qt Assistant if one is open.
.P
Each page file entry is assumed to be relative to the default prefix
.B qthelp://bl3demc/IMOD
unless the
.B -q
option is entered with a different relative or absolute prefix.  If the
.B -b
option is entered, then the prefix must be a fully qualified one for the qhc
file being used; otherwise, the prefix is simply appended to qthelp://bl3demc/IMOD/.
.P
By default, the Assistant sidebar will be started with an argument to hide the
sidebar.  Use the 
.B -k
option to omit this argument and keep the sidebar open if the user had opened
it.
.P
A completely unrelated behavior is available by running the program with
"imodqtassist -t".  In this case it will output the "Ideal thread count",
equivalent to the number of processors reported by the system, and exit.
.SH AUTHOR
David Mastronarde,  mast@colorado.edu
