.na
.nh
.TH MRCX 1 2.40 BL3DEMC
.SH NAME
mrcx \- Convert MRC files between different operating systems

.SH SYNOPSIS
mrcx [-vms|-ieee] filename [optional output filename]
.SH DESCRIPTION
Numbers are stored on computers in two different orders, termed
"little-endian" (as on Windows and Linux PCs and Macs with Intel processors)
and "big-endian" (as on Macs with PowerPC processors and some older machines).
Moreover, Unix machines store floating-point numbers in IEEE
format, while VMS machines stored them in a slightly different format.  Mrcx
can convert MRC image files from one machine's format to another by swapping
bytes and, when necessary, converting the format of the floating-point
numbers.
.PP
The type of data conversion is specified with the
.B -vms
or
.B -ieee
option.  (The "Usage" statement issued by entering mrcx without arguments will
indicate which is the default, probably ieee).  Namely,
.B -vms
will convert files between VMS format and big-endian Unix format, while
.B -ieee
will convert files between little-endian and big-endian Unix formats.
.PP
If an output filename is given, then the converted data are written to a new
file; otherwise they are written back into the input file.  Conversion is
completely reversible, so if an erroneous command is given to convert a file
in place, just issue the same command to undo it.

.SH AUTHORS
Ross Dargahi, Jim Kremer, and David Mastronarde

.SH BUGS
Extra data in the extended image header are converted as short integers, which
works for data from SerialEM but not for extended headers in the FEI/Agard
format.

Conversion to and from VMS format is available only on big-endian machines.

There is no longer an attempt to write a new title for the conversion.

Email bug reports to mast@colorado.edu.
