.na
.nh
.TH selfalign 1 2.50 BL3DEMC
.SH NAME
selfalign \- Realign model based on fits to trajectories
.SH SYNOPSIS
selfalign [options] <root_name | input_file output_file>
.SH DESCRIPTION
selfalign will refine the alignment of a model of fibers that progress through
the Z-dimension, such as microtubules modeled through serial sections, using
the trajectories in the model.  This provides a way of smoothing a model
without disrupting the spacings between fibers in a section, which would happen
if trajectories were smoothed independently with mtsmooth(1).  selfalign works
by first running xfmodel(1) to
obtain transformations relating each section to the previous one (f 
transforms).  The kind of transformation can be specified with the
.B -t
option, e.g., full linear, rotations and translations only, etc.  If there
are few fibers, it is appropriate to reduce the complexity of transformations
being solved for.  In addition, one can
specify the range of sections in the model over which to solve for
transformations, and thus exclude regions near the ends of the model that have
few fibers.  If sections are excluded at the start or end of the model, 
selfalign supplies transforms for those sections by replicating the first or 
last transform actually solved for, respectively.  This prevents artifacts
when local fits are made to the trends in the transforms.
The f transforms are
converted to g transforms using xftoxg(1), using fitting parameters that
can be adjusted with the 
.B -l
and
.B -o
options.  The self-aligned model is produced by running imodtrans(1).

The program can be run with either one or two arguments after the options.
Use one argument to specify a root filename.  The program then
assumes that the input model is root_name.mod and generates an output 
model named root_name.selfmod.  Alternatively, use two arguments to
specify the full names of the input and output models.
In this case, the root name for the other files is assumed to be the name of 
the input model with any extension removed.
.SS Options
Run selfalign with no arguments to get a usage statement listing the default
values of the parameters.
.TP
.B -s <list>
Solve for transformations over the range of sections given in 
.I list.
A single range (e.g., 3-32) will give best results.  
The default is to solve over the whole extent of the model.
.TP
.B -l <extent>
Do local fits to transformation parameters over the number of sections given
in
.I extent.
This parameter is used in running xftoxg(1).
.TP
.B -o <order>
Set the polynomial order for the local fits to 
.I order.
This parameter is also used in running xftoxg(1).
.TP
.B -t <type>
Specify the type of transformations to solve for; set 
.I type
to 0 for general linear transforms, 2 for translations only, 3 for 
rotations and translations, or 4 for magnifications, rotations and 
translations.
.TP
.B -i <file>
Specify the name of the image stack upon which the model was built.  If no
file is entered, the default is the root name of the model with extension .ali.
If such an image file is not available, the program will extract the needed
information about image dimensions from the header of the model, and assume
that this will adequately represent the information that could be extracted
from the image file header.
.SH FILES
In addition to the self-aligned model, the program creates files with the
f transforms (root_name.selfxf) and the g transforms (root_name.selfxg).
If any of the output files already exists a backup
of the original is created
with the ~ extension.
.SH AUTHOR
David Mastronarde  <mast@colorado.edu>
.SH SEE ALSO
xfmodel(1), xftoxg(1), imodtrans(1)
